#include <stdio.h>
#include <sys/types.h>
#include "util.h"



int main() 
{
    

    phys_para const pp = load_para();
     
    // ------------ parameters ---------------
    double const AA=pp.t; // set to 1.0 in parameters
    double const phi=pp.V;// not used
    double const M=pp.es;//Mass term
    int const L=pp.L;
    float BB = pp.exy;//not used
    float C = pp.exz;//not used
    float D =pp.eyz;//not used

        
    // ------------ parameters ---------------

//------------------------- print parameters--------------------------------
    printf("-------------------------- Parameters ------------------------------\n");
    printf("\tL=%d\t A=%g \t Phi=%g \t M=%g\t B=%g\t C=%g\t D=%g\n", L, AA,phi,M,BB,C,D);
    printf("--------------------------------------------------------------------\n\n");
    //--------------------------------------------------------------------------
    
    int i, j,j2; 
    gsl_matrix_complex * g1 = gsl_matrix_complex_alloc (2, 2);
    gsl_matrix_complex * g2 = gsl_matrix_complex_alloc (2, 2);
    gsl_matrix_complex * g3 = gsl_matrix_complex_alloc (2, 2);
    gsl_matrix_complex * g4 = gsl_matrix_complex_alloc (2, 2);

    
    gsl_matrix_complex * A = gsl_matrix_complex_alloc (2,2);
    gsl_matrix_complex * B = gsl_matrix_complex_alloc (2,2);
    
    gsl_matrix_complex * H = gsl_matrix_complex_alloc (2*L,2*L);
    
    gsl_eigen_hermv_workspace * w = gsl_eigen_hermv_alloc (2*L);
    gsl_vector * eval = gsl_vector_alloc(2*L);
    gsl_matrix_complex * evec = gsl_matrix_complex_alloc(2*L,2*L);
    
    gsl_matrix_complex * cmat_temp = gsl_matrix_complex_alloc (2,2);
    gsl_complex A_temp, B_temp;
    
    gsl_complex A1,A2,A3,A4;  //coefficients of gammas in A
    gsl_complex B1,B2,B3,B4;  //coefficients of gammas in B
    
    FILE * f;
    FILE * f2;
    char file[100];

    double temp;
    
    gsl_matrix * klist=gsl_matrix_alloc(10,3);
    
    double k[]={0};
    
    int ki=0;
    int kL=100;

//  prepare sigma matrices
    load_sigma(g1,g2,g3,g4);

        


//Load list of k-vectors
    klist=load_klistone();
    if(klist==NULL)
    {
        printf("Failed to load k's");
        return -1;
    }
    
    kL = klist->size1; // # of lines
     
    if( kL < 1) 
    {
        printf("\n No k read from file klist.txt\n");
        return 0;   
    }
    
    ki=0;
    printf("%d sets of k loaded.\n", kL);
  
    printf("\nCalculating spectrums...\n\n");
    
    f = fopen ("eval.dat", "w");// This is to clear existing content
    fclose(f);
  
    while(ki< kL)
    {
        
        k[0]=gsl_matrix_get(klist,ki,0)*PI;
    
        
        ki++;
        
        printf("k1 = %g \n", k[0]/PI);


    
       //prepare A
       A2 = gsl_complex_rect(0,0);
       A1 = gsl_complex_rect(AA*sin(k[0]),0);
       A3 = gsl_complex_rect((2-(M)-cos(k[0])),0);
       A4 = gsl_complex_rect(0,0); 
       //prepare B
        B1 = gsl_complex_rect(0,0);
        B2 = gsl_complex_rect(0,-0.5*AA);
        B3 = gsl_complex_rect(0.5,0);
        B4 = gsl_complex_rect(0,0);
    
        // prepare the matrix H to be diagonalized
        gsl_matrix_complex_set_zero(H);
    
        for(j=0;j<2;j++)
         for(j2=0;j2<2;j2++)
        {
        
            for(i=1;i<L-1;i++)
            {               
     
        
//------------------------------------------------------
        
        gsl_matrix_complex_set_zero(A);
        gsl_matrix_complex_memcpy(A,g1);
        gsl_matrix_complex_scale(A, A1);

        gsl_matrix_complex_memcpy(cmat_temp,g2);
        gsl_matrix_complex_scale(cmat_temp, A2);
        gsl_matrix_complex_add(A,cmat_temp);

        gsl_matrix_complex_memcpy(cmat_temp,g3);
        gsl_matrix_complex_scale(cmat_temp, A3);
        gsl_matrix_complex_add(A,cmat_temp);

        gsl_matrix_complex_memcpy(cmat_temp,g4);
        gsl_matrix_complex_scale(cmat_temp, A4);
        gsl_matrix_complex_add(A,cmat_temp);

    
    
    
        //prepare B
        gsl_matrix_complex_set_zero(B);
        gsl_matrix_complex_memcpy(B,g1);
        gsl_matrix_complex_scale(B, B1);

        gsl_matrix_complex_memcpy(cmat_temp,g2);
        gsl_matrix_complex_scale(cmat_temp, B2);
        gsl_matrix_complex_add(B,cmat_temp);

        gsl_matrix_complex_memcpy(cmat_temp,g3);
        gsl_matrix_complex_scale(cmat_temp, B3);
        gsl_matrix_complex_add(B,cmat_temp);

        gsl_matrix_complex_memcpy(cmat_temp,g4);
        gsl_matrix_complex_scale(cmat_temp, B4);
        gsl_matrix_complex_add(B,cmat_temp);

                
        A_temp = gsl_matrix_complex_get(A,j,j2);
            B_temp = gsl_matrix_complex_get(B,j,j2);
                
                gsl_matrix_complex_set(H,(i-1)*2+j,(i-1)*2+j2, A_temp);
                
                gsl_matrix_complex_set(H,(i-1)*2+j2,i*2+j, gsl_complex_conjugate(B_temp));
                gsl_matrix_complex_set(H,i*2+j,(i-1)*2+j2, B_temp);
            }
        


        gsl_matrix_complex_set_zero(A);
        gsl_matrix_complex_memcpy(A,g1);
        gsl_matrix_complex_scale(A, A1);

        gsl_matrix_complex_memcpy(cmat_temp,g2);
        gsl_matrix_complex_scale(cmat_temp, A2);
        gsl_matrix_complex_add(A,cmat_temp);

        gsl_matrix_complex_memcpy(cmat_temp,g3);
        gsl_matrix_complex_scale(cmat_temp, A3);
        gsl_matrix_complex_add(A,cmat_temp);

        gsl_matrix_complex_memcpy(cmat_temp,g4);
        gsl_matrix_complex_scale(cmat_temp, A4);
        gsl_matrix_complex_add(A,cmat_temp);
                      A_temp = gsl_matrix_complex_get(A,j,j2);
        gsl_matrix_complex_set(H,(L-2)*2+j,(L-2)*2+j2,A_temp);
        }

        

    //diagonalizing H and get spectrum
    
        gsl_vector_set_zero(eval);
        gsl_matrix_complex_set_zero(evec);
        check_hermitian(H,2*L);


      //for 2 k-vectors near the Gamma point calculate the eigenvalues AND eigenfunctions
       if(ki==190||ki==210  )
       {
       gsl_eigen_hermv(H,eval,evec,w);
        gsl_eigen_hermv_sort(eval,evec,GSL_EIGEN_SORT_VAL_ASC);

     //save the real and imaginary parts of the wavefunctions
      sprintf(file, "Rvec%d.dat",ki);
      f=fopen(file,"w");
    
      sprintf(file, "Ivec%d.dat",ki);
      f2=fopen(file,"w");
    
      fprint_cmat2(evec, 2*L,2*L,f,f2);
    
      fclose(f);
      fclose(f2);
       }
    
    
       //for all other k-vectors just calculate the eigenvalues to save time
        gsl_eigen_herm(H,eval,w);
        gsl_eigen_hermv_sort(eval,evec,GSL_EIGEN_SORT_VAL_ASC);
    
        f = fopen ("eval.dat", "a+");
        fprintf(f,"\n%g", k[0]);
        fprint_vec(eval,2*L,f);
        fclose(f);
    

    }
    
    
    gsl_matrix_complex_free(g1);
    gsl_matrix_complex_free(g2);
    gsl_matrix_complex_free(g3);
    gsl_matrix_complex_free(g4);
    gsl_matrix_complex_free(A);
    gsl_matrix_complex_free(B);
    gsl_matrix_complex_free(H);   
    gsl_matrix_complex_free(evec);      
    gsl_matrix_complex_free(cmat_temp);        
    gsl_matrix_free(klist);
    gsl_eigen_hermv_free(w);
    gsl_vector_free(eval);
     
    
    return 0;
 

}
